Attribute VB_Name = "Public"
'          APPLE.STYLE TYPES!
Public Const NORMAL As Integer = 0 'normal
Public Const POISON As Integer = 1 'makes snake shorter
Public Const ROTTEN As Integer = 2 'random length
Public Const PSYCHO As Integer = 3 'swaps colours
Public Const STEROIDS As Integer = 4 'twice as long
Public Const ENDS As Integer = 5 'swap ends
Public Const HALF As Integer = 6 'half length
Public Const HEALTH As Integer = 7 'just gives health
Public Const FLAG1 As Integer = 8
Public Const FLAG2 As Integer = 9
Public Const QUAD As Integer = 10
Public Const RedHot As Integer = 11
Public Const HEAD As Integer = 12

Public Type vector2
    x As Integer
    y As Integer
End Type
Public Type player
    colour As Long
    Kicked As Boolean 'whether players controls are disabled
    LastCoord As Integer
    CurrentCoord As Integer
    Direction As Integer ' what player has typed as direction
    WinCount As Integer ' cumulative total of all wins
    Keys(3) As Integer
    Length As Integer 'length snake _should_ be
    Keyed As Boolean 'has player typed key yet?
    coords(3000) As vector2
    OnBoard As Boolean 'whether player is on the board, or ultimately dead.
    Flag As Integer 'whether play has a flag
    Team As Integer 'what team player is on
    Frags As Integer
    RespawnTime As Integer
    Quaded As Integer
    RedHotted As Integer '0 for not >0 for yes, decreases every cycle
    QuadIndex As Integer 'what apple is attached
    RedHotIndex As Integer 'what apple is attached
End Type
Public Type Apple
    style As Integer 'refer to constants at top
    x As Integer
    y As Integer
    Carrying As Integer
    RespawnTime As Integer
End Type

Public StartPos(3) As vector2
Public StartDir(3) As Integer

Public Apple() As Apple
Public QApple() As Apple
Public P(3) As player
Public Q(3) As player 'backup of player array
Public Arena() As Byte 'just a big array of 1s and 0s corresponding to where you can go and where you cant respectavely

Public WinPoints As Integer, LosePoints As Integer
Public MinPoints As Integer, MaxPoints As Integer
Public OtherPoints As Integer
Public ApplePoints As Integer, MaxPointsApple As Integer

Public StartLength As Integer
Public MaxLen As Integer
Public MinLen As Integer
Public AppleAddLen As Integer
Public AppleSubLen As Integer

Public ShrinkRate1 As Integer
Public ShrinkRate2 As Integer

Public KeysIn(3) As Integer

Public MinLineLen As Integer
Public MaxLineLen As Integer

Public AppleColour(12) As Long
Public NumApples(12) As Integer 'numbers / ratios of apples
Public NumApples2 As Integer 'number of apples for ratio mode
Public FPSCount As Integer 'necessary for doing FPS averages, see formmain.draw
Public StartTime As Single
Public TimeLimit As Single
Public Fraglimit As Integer
Public IniFileName As String
Public RespawnTime As Integer
Public PowerupTime As Integer

Public Sub Main()
    If App.PrevInstance Then MsgBox "Already Loaded!": End
    ReDim Apple(0)
    ReDim QApple(0)
    ReDim Arena(0, 0)
    IniFileName = Command$
    If IniFileName = "" Then IniFileName = "winduel.ini"
    Load FormMain
    FormMain.Visible = True
End Sub
